//-----------------------------------------------------------------------------
//	CANRlN^i[^[GR[_Ƃovlj			A.Fukumori	2007/11/10
//
//-----------------------------------------------------------------------------
// ڑdl
//
//	------ CN3 ---------	------ CN4 ---------	
//													
//	10	A-		----		1	----	----		
//	9	A+		----		2	P6-0	A(hard)	
//	8	P5-0	----		3	P6-1				
//	7	P5-1	----		4	P6-2	A(soft)	
//	6	P5-2	----		5	P6-3	B(soft)	
//	5	P5-3	----		6	P6-4				
//	4	P5-4	----		7	P6-5	PWM			
//	3	P5-5	----		8	P6-6	DIO			
//	2	P5-6	----		9	P6-7	DIO			
//	1	P5-7	----		10	GND		GND			
//
//-----------------------------------------------------------------------------
//#include "iodefine.h"


//-----------------------------------------------------------------------------
// 	p֐Q										A.Fukumori	2007/11/09
//-----------------------------------------------------------------------------
extern void CAN_Command_Read(unsigned char id);

int ENC_MODE(unsigned int d);
int ENC_TPSC(unsigned int d);
int ENC_PWM(unsigned int d);
int ENC_DUTY(unsigned int d);
int ENC_Loop(void);


//-----------------------------------------------------------------------------
// 	f[^\										A.Fukumori	2007/11/09
//-----------------------------------------------------------------------------
struct
{
	union
	{
		struct
		{
			unsigned long	D1		:32;	// BYTE0,1,2,3
		}DWORD;
		struct
		{
			unsigned int	W2		:16;	// BYTE0,1
			unsigned int	W1		:16;	// BYTE2,3
		}WORD;
		struct
		{
			unsigned char	B4		: 8;	// BYTE0
			unsigned char	B3		: 8;	// BYTE1
			unsigned char	B2		: 8;	// BYTE2
			unsigned char	B1		: 8;	// BYTE3
		}BYTE;
	}DATA;
}				ENC_Pulse={0};	// GR[_l
unsigned long	ENC_CW=0;		// GR[_l


//-----------------------------------------------------------------------------
//	ENC 											A.Fukumori	2007/11/09
//-----------------------------------------------------------------------------
int ENC_MODE(unsigned int d)
{
	if(d)
	{
		// PIO
		IO.PCR6				= 0x00;		// 0000 0000	0:͐ݒ	1:o͐ݒ
		IO.PDR6.BYTE		= 0x00;		// 0000 0000	1:5Vo	0:0Vo
		ICN[ID_ENC_PC].DATA.BYTE.B1 = IO.PCR6;
		ICN[ID_ENC_DO].DATA.BYTE.B1 = IO.PDR6.BYTE;

		// Z0^C}
		TZ.TSTR.BIT.STR0	= 0;	// TCNT_0 ̓JEg~
		TZ0.TCR.BIT.TPSC	= 4;	// ONbNFTCLK [q͂ŃJEg
		TZ0.TCR.BIT.CKEG	= 2;	// オ^̗GbWŃJEg
		TZ0.TCNT			= 0;	// JE^NA
		TZ.TFCR.BIT.STCLK	= 1;	// ONbN̓ZNg
									//				i1FONbN͗Lj
		TZ.TSTR.BIT.STR0	= 1;	// TCNT_0 ̓JEgJn
	}
	else
	{
		TZ.TSTR.BIT.STR0	= 0;	// TCNT_0 ̓JEg~
	}
	return 0;
}

//-----------------------------------------------------------------------------
//	
//-----------------------------------------------------------------------------
int ENC_TPSC(unsigned int d)
{
	if(d)
	{
		// PIO
		IO.PCR6				= 0x30;		// 0011 0000	0:͐ݒ	1:o͐ݒ
		IO.PDR6.BYTE		= 0x00;		// 0000 0000	1:5Vo	0:0Vo
		ICN[ID_ENC_PC].DATA.BYTE.B1 = IO.PCR6;
		ICN[ID_ENC_DO].DATA.BYTE.B1 = IO.PDR6.BYTE;

		// Z1^C}
		TZ.TSTR.BIT.STR1	= 0;	// JE^~
		TZ1.TCR.BIT.TPSC	= d;	// ^C}vXP[
		TZ1.TCR.BIT.CCLR	= 1;	// JE^NA
		//i001FGRA ̃RyA}b`^CvbgLv`TCNT NAj
		TZ.TPMR.BIT.PWMB1	= 1;	// TPMRFTIOA1PWM[hɕύX
		TZ.TOCR.BIT.TOB1	= 0;	// o͂̐ݒ  FTIOB10o
		TZ1.POCR.BIT.POLB	= 0;	// ANeBux̐ FTIOB1͏o̓x0
		TZ1.TCNT			= 0;	// JE^NA
		TZ1.GRA				= TZ1.GRC;	// PWM
		//i20000kHzTZ0.GRAPWMj
		TZ1.GRB				= TZ1.GRD;	// f[eB[̐ݒ	
		//iTZ0.GRBPWMf[eB[j
		TZ.TMDR.BIT.BFC1	= 1;	// obt@
		//i1FGRA_1 GRC_1 ̓obt@j
		TZ.TMDR.BIT.BFD1	= 1;	// obt@
		//i1FGRB_1 GRD_1 ̓obt@j
//		TZ1.GRC				= 0;	// obt@
		//iTZ1.GRCPWMf[eB[j
//		TZ1.GRD				= 0;	// obt@
		//iTZ1.GRDPWMf[eB[j
		TZ.TOER.BIT.EB1		= 0;	// }X^Cl[u
		//i0FTPMRATFCRATIORA_0 ̐ݒɏ]AFTIOA1 [q̏o͂͋j
		TZ.TSTR.BIT.STR1	= 1;	// JE^Jn
	}
	else
	{
		// ̏ꂵ̂EEEB
		TZ1.GRD = 0;
		// ovl̉Lq
//		TZ.TSTR.BIT.STR1	= 0;	// JE^~
	}
	return 0;
}

//-----------------------------------------------------------------------------
//	PWM o͎
//-----------------------------------------------------------------------------
int ENC_PWM(unsigned int d)
{
	TZ1.GRC	= d;
	return 0;	
}

//-----------------------------------------------------------------------------
//	PWM oDuty
//-----------------------------------------------------------------------------
int ENC_DUTY(unsigned int d)
{
	TZ1.GRD	= d;
	return 0;
}

//-----------------------------------------------------------------------------
//	
//-----------------------------------------------------------------------------
void Raed_ID_ENC_MODE(void)
{
	
}

//-----------------------------------------------------------------------------
//	
//-----------------------------------------------------------------------------
void Raed_ID_ENC_L(void)
{
	if(ICN[ID_MODE].DATA.BYTE.B2 == ID_ENC_MODE)
	{
		ICN[ID_ENC_L].DATA.WORD.W1 = ENC_Pulse.DATA.WORD.W1;
	}
}

//-----------------------------------------------------------------------------
//	
//-----------------------------------------------------------------------------
void Raed_ID_ENC_H(void)
{
	if(ICN[ID_MODE].DATA.BYTE.B2 == ID_ENC_MODE)
	{
		ICN[ID_ENC_H].DATA.WORD.W1 = ENC_Pulse.DATA.WORD.W2;
	}
}

//-----------------------------------------------------------------------------
//	
//-----------------------------------------------------------------------------
void Raed_ID_ENC_CW(void)
{
	if(ICN[ID_MODE].DATA.BYTE.B2 == ID_ENC_MODE)
	{
		ICN[ID_ENC_CW].DATA.WORD.W1 = ENC_CW;
	}
}

//-----------------------------------------------------------------------------
//	
//-----------------------------------------------------------------------------
void Raed_ID_ENC_TPSC(void)
{

}

//-----------------------------------------------------------------------------
//	
//-----------------------------------------------------------------------------
void Raed_ID_ENC_PWM(void)
{

}

//-----------------------------------------------------------------------------
//	
//-----------------------------------------------------------------------------
void Raed_ID_ENC_DUTY(void)
{

}

//-----------------------------------------------------------------------------
//	
//-----------------------------------------------------------------------------
void Raed_ID_ENC_DUTY_EX(void)
{

}

//-----------------------------------------------------------------------------
//	
//-----------------------------------------------------------------------------
void Raed_ID_ENC_PU(void)
{
	
}

//-----------------------------------------------------------------------------
//	
//-----------------------------------------------------------------------------
void Raed_ID_ENC_PC(void)
{
	
}

//-----------------------------------------------------------------------------
//	
//-----------------------------------------------------------------------------
void Raed_ID_ENC_DI(void)
{
	if(ICN[ID_MODE].DATA.BYTE.B1==0)
	{
		ICN[ID_ENC_DI].DATA.BYTE.B1 = IO.PDR6.BYTE & 0xF0;
	}
}

//-----------------------------------------------------------------------------
//	
//-----------------------------------------------------------------------------
void Raed_ID_ENC_DO(void)
{

}

//-----------------------------------------------------------------------------
//	
//-----------------------------------------------------------------------------
void Write_ID_ENC_MODE(unsigned char low ,unsigned char hi)
{
	if(ICN[ID_MODE].DATA.BYTE.B2==0)
	{
		ICN[ID_ENC_MODE].DATA.BYTE.B1 = low;
		ICN[ID_ENC_MODE].DATA.BYTE.B2 = hi;
		if(ICN[ID_ENC_MODE].DATA.WORD.W1)
		{
			ICN[ID_MODE].DATA.BYTE.B2 = ID_ENC_MODE;
			ENC_MODE(1);
		}
	}
	else if(ICN[ID_MODE].DATA.BYTE.B2 == ID_ENC_MODE)
	{
		ICN[ID_ENC_MODE].DATA.BYTE.B1 = low;
		ICN[ID_ENC_MODE].DATA.BYTE.B2 = hi;
		if(ICN[ID_ENC_MODE].DATA.WORD.W1==0)
		{
			ENC_MODE(0);
			ENC_TPSC(0);
			ICN[ID_MODE].DATA.BYTE.B2	= 0;
			ICN[ID_P6_PC].DATA.BYTE.B1	= IO.PCR6;
			ICN[ID_P6_DI].DATA.BYTE.B1	= IO.PDR6.BYTE;
			ICN[ID_P6_DO].DATA.BYTE.B1	= IO.PDR6.BYTE;
		}
	}
}

//-----------------------------------------------------------------------------
//	
//-----------------------------------------------------------------------------
void Write_ID_ENC_L(unsigned char low ,unsigned char hi)
{
	if(ICN[ID_MODE].DATA.BYTE.B2 == ID_ENC_MODE)
	{
		ENC_Pulse.DATA.BYTE.B1 = low;
		ENC_Pulse.DATA.BYTE.B2 = hi;
	}
}

//-----------------------------------------------------------------------------
//	
//-----------------------------------------------------------------------------
void Write_ID_ENC_H(unsigned char low ,unsigned char hi)
{
	if(ICN[ID_MODE].DATA.BYTE.B2 == ID_ENC_MODE)
	{
		ENC_Pulse.DATA.BYTE.B3 = low;
		ENC_Pulse.DATA.BYTE.B4 = hi;
	}
}

//-----------------------------------------------------------------------------
//	
//-----------------------------------------------------------------------------
void Write_ID_ENC_CW(unsigned char low ,unsigned char hi)
{

}

//-----------------------------------------------------------------------------
//	
//-----------------------------------------------------------------------------
void Write_ID_ENC_TPSC(unsigned char low ,unsigned char hi)
{
	if(ICN[ID_MODE].DATA.BYTE.B2 == ID_ENC_MODE)
	{
		ICN[ID_ENC_TPSC].DATA.BYTE.B1 = low;
		ICN[ID_ENC_TPSC].DATA.BYTE.B2 = 0;
		switch(ICN[ID_ENC_TPSC].DATA.BYTE.B1)
		{
		case 0x01:	// 
			ENC_TPSC(0);
			break;
		case 0x02:	// /2
			ENC_TPSC(1);
			break;
		case 0x04:	// /4
			ENC_TPSC(2);
			break;
		case 0x08:	// /8
			ENC_TPSC(3);
			break;
		default:	// 
			ENC_TPSC(0);
			break;		
		}
	}
}

//-----------------------------------------------------------------------------
//	
//-----------------------------------------------------------------------------
void Write_ID_ENC_PWM(unsigned char low ,unsigned char hi)
{
	if(ICN[ID_MODE].DATA.BYTE.B2 == ID_ENC_MODE)
	{
		ICN[ID_ENC_PWM].DATA.BYTE.B1 = low;
		ICN[ID_ENC_PWM].DATA.BYTE.B2 = hi;
		ENC_PWM(ICN[ID_ENC_PWM].DATA.WORD.W1);
	}
}

//-----------------------------------------------------------------------------
//	
//-----------------------------------------------------------------------------
void Write_ID_ENC_DUTY(unsigned char low ,unsigned char hi)
{
	if(ICN[ID_MODE].DATA.BYTE.B2 == ID_ENC_MODE)
	{
		ICN[ID_ENC_DUTY].DATA.BYTE.B1 = low;
		ICN[ID_ENC_DUTY].DATA.BYTE.B2 = hi;
		ENC_DUTY(ICN[ID_ENC_DUTY].DATA.WORD.W1);
	}
}

//-----------------------------------------------------------------------------
//	
//-----------------------------------------------------------------------------
void Write_ID_ENC_DUTY_EX(unsigned char low ,unsigned char hi)
{
	if(ICN[ID_MODE].DATA.BYTE.B2 == ID_ENC_MODE)
	{
		ICN[ID_ENC_DUTY_EX].DATA.BYTE.B1 = low;
		ICN[ID_ENC_DUTY_EX].DATA.BYTE.B2 = hi;
		ENC_DUTY(ICN[ID_ENC_PWM].DATA.WORD.W1 - ICN[ID_ENC_DUTY_EX].DATA.WORD.W1);
	}
}

//-----------------------------------------------------------------------------
//	
//-----------------------------------------------------------------------------
void Write_ID_ENC_PU(unsigned char low ,unsigned char hi)
{

}

//-----------------------------------------------------------------------------
//	
//-----------------------------------------------------------------------------
void Write_ID_ENC_PC(unsigned char low ,unsigned char hi)
{
	if(ICN[ID_MODE].DATA.BYTE.B1==ID_ENC_MODE)
	{
		ICN[ID_ENC_PC].DATA.BYTE.B1 = low & 0xF0;
		IO.PCR6  = (ICN[ID_ENC_PC].DATA.BYTE.B1)|(IO.PDR6.BYTE&0x0F);
	}
}

//-----------------------------------------------------------------------------
//	
//-----------------------------------------------------------------------------
void Write_ID_ENC_DI(unsigned char low ,unsigned char hi)
{

}

//-----------------------------------------------------------------------------
//	
//-----------------------------------------------------------------------------
void Write_ID_ENC_DO(unsigned char low ,unsigned char hi)
{
	if(ICN[ID_MODE].DATA.BYTE.B1==ID_ENC_MODE)
	{
		ICN[ID_ENC_DO].DATA.BYTE.B1 = low & 0xF0;
		IO.PDR6.BYTE = (ICN[ID_ENC_DO].DATA.BYTE.B1)|(IO.PDR6.BYTE&0x0F);
	}
}
//-----------------------------------------------------------------------------
//	ENC	p[v										A.Fukumori	2007/11/10
//-----------------------------------------------------------------------------
int ENC_Loop(void)
{
	const unsigned long dir[16] = {0,1,-1,2,-1,0,2,1,1,2,0,-1,2,-1,1,0};
	unsigned char	now;		// ݒl
	unsigned char	edge;		// ωl


	now = IO.PDR6.BIT.B3<<1 | IO.PDR6.BIT.B2;			// ݒl
	while(CAN_Receive_Send())							// 󑗐M
	{
		edge = IO.PDR6.BIT.B3<<1 | IO.PDR6.BIT.B2;		// ωl
		if(!(edge==now))								// GbWo
		{
			ENC_CW	= dir[now<<2|edge];					// CfbNX
			if(ENC_CW==2) break;						// s
			ENC_Pulse.DATA.DWORD.D1 += ENC_CW*TZ0.TCNT;	// GR[_lXV
			TZ0.TCNT = 0;								// JE^NA
			break;
		}
	}
	return 0;
}
