#include	"main.h"
#ifdef		_MAIN60_CPP_	// 얢mF
//-----------------------------------------------------------------------------
//	main60_cppiC8420j									A.Fukumori	2007/10/24
//-----------------------------------------------------------------------------
//	2007/10/24	A.Fukumori	


//-----------------------------------------------------------------------------
//	p[^
//-----------------------------------------------------------------------------
#define			DIV		1000		// [count]
#define			DT		5		// [msec]


//-----------------------------------------------------------------------------
//	p[^iŗLlj
//-----------------------------------------------------------------------------
#define			ICN_IF		"IFCAN1"	// 
#define			ICN_ID		278			// MAC-ID


//-----------------------------------------------------------------------------
//	include
//-----------------------------------------------------------------------------
#include		<windows.h>
#include		<stdio.h>
#include		"ICN.h"


//-----------------------------------------------------------------------------
//	
//-----------------------------------------------------------------------------
char			END_Key = 0;			// 
MMRESULT		ulTimerID;				// 
TIMECALLBACK	TimeProc;				// 


//-----------------------------------------------------------------------------
//	main
//-----------------------------------------------------------------------------
int main(void)
{
	int				nRet;
	int				i;
	unsigned int	data;
	unsigned long	tss;
	unsigned long	te,ts;

	unsigned long	C8420_T[DIV] = {0};
	unsigned long	C8420_L[DIV] = {0};
	unsigned int	C8420_S[DIV] = {0};

	char			filename[FILENAME_MAX];
	FILE			*output;
	SYSTEMTIME		w;


	//-------------------------------------------------------------------------
	//	Jn
	//-------------------------------------------------------------------------
	timeBeginPeriod(1);								// timeGettime xAbv
	Sleep(1000);									// 1000ms҂
	nRet = ICN_Open(ICN_ID,ICN_IF,ICN_BAUDRATE_1M);	// CanOpen

	// Mode_C8420(170) Delay(42)
	nRet = ICN_Send_S(ICN_ID,170,42);
	data = ICN_Get_WORD(ICN_ID,170,"MODE_C8420");

	ulTimerID = timeSetEvent(1,0,TimeProc,0,TIME_ONESHOT); //P^C}Cxg
	//-------------------------------------------------------------------------
	//	s
	//-------------------------------------------------------------------------
	tss = timeGetTime(); //MJn
	ts = tss;
	i = 0;
	while(1)
	{
		if(END_Key==1) break;
		te = timeGetTime(); //MJn
		if(te-ts>=DT)
		{
			ts = te;

			// C8420_RECV_L(171),C8420_RECV_H(172),C8420_S(174) 
			nRet = ICN_Send_C(ICN_ID,171,172,174);
//			nRet = ICN_Send_C(ICN_ID,173,174,0xFF);
			C8420_T[i] = te - tss;
			C8420_L[i] = ICN_Get_DWORD(ICN_ID,171,172);
			C8420_S[i] = ICN_Get_WORD(ICN_ID,174);

//			if(!(i%(int)(DIV/10)))
				printf("T=%6ld/[msec],L=%6ld/[mm],S=%4d/[-]\n",
							C8420_T[i],C8420_L[i],C8420_S[i]);
			i++;
			if(i>=DIV) break;
		}
	}

	//-------------------------------------------------------------------------
	//	f[^
	//-------------------------------------------------------------------------
	printf("f[^ݒ\n");

	GetLocalTime(&w);
	sprintf(filename,"%04d%02d%02d%02d%02d%02d_main60.csv",
						w.wYear,w.wMonth,w.wDay,w.wHour,w.wMinute,w.wSecond);

	if(output = fopen(filename,"w"))
	{
		fprintf(output,"CNT/[count],T/[msec],L/[mm],S/[-]\n");

		for(i=0;i<DIV;i++)
			fprintf(output,"%d,%ld,%ld,%d\n",i,C8420_T[i],C8420_L[i],C8420_S[i]);

		if(fclose(output))
			printf("t@C̂Ɏs܂\n");
	}
	else
	{
		printf("t@CĴɎs܂\n");
	}

	printf("f[^ݏI\n");
	//-------------------------------------------------------------------------
	//	I
	//-------------------------------------------------------------------------
	nRet = ICN_Close(ICN_ID,"ICN_ID");		// CanClose

	//-------------------------------------------------------------------------
	//	̑
	//-------------------------------------------------------------------------
	printf("<Press Enter (END)>\n");
	scanf("%c",&END_Key);
	ShellExecute(0,0,filename,0,0,0);	// t@CJ
	timeEndPeriod(1);	// timeGettime xAbvI
	return 0;
}

//-----------------------------------------------------------------------------
//	P^C}Cxg
//-----------------------------------------------------------------------------
void CALLBACK TimeProc(UINT uID,UINT uMsg,DWORD dwUser,DWORD dw1,DWORD dw2)
{
	scanf("%c",&END_Key);	// fEnter݂̂
	END_Key = 1;
}
#endif