//-----------------------------------------------------------------------------
//	ICN_Close_cpp										A.Fukumori	2007/07/15
//
//	vgRˑFICN		n[hˑFWindows, CANCard
//-----------------------------------------------------------------------------
//	2007/05/19	A.Fukumori	ŁiCANUPC̓΍j
//	2007/05/19	A.Fukumori	ICNgpCAN_Closeł͂ȂICN_CloseĂяo
//	2007/05/24	A.Fukumori	CAN_Close,CAN_Status,CAN_Print
//	2007/05/26	A.Fukumori	JI


//-----------------------------------------------------------------------------
//	include
//-----------------------------------------------------------------------------
#include	<windows.h>		// Windows:	Sleep()
#include	<stdio.h>		// C:		printf()
#include	"sim.h"
#include	"IFCan.h"		// CANCard:	...
#include	"IFCANPF.h"		// CANCard:	...
#include	"ICN.h"


//-----------------------------------------------------------------------------
//	
//-----------------------------------------------------------------------------
extern struct tICN_IF
{
	char		Name[7];
	HANDLE		hDeviceHandle;
}
ICN_IF[ICN_IF_MAX];

extern		int				ICN_IF_cnt;
extern		unsigned long	ICN_Time;
extern		HANDLE			hDeviceHandle[512];


//-----------------------------------------------------------------------------
// CAN C^tF[XN[Y܂B
//-----------------------------------------------------------------------------
int	ICN_Close	(unsigned long	MAC,
				 char*			String)
{
	CAN_PORT_STATUS		pStatus;
	int					i;
	int					nRet;

//	printf("in\t: ICN_Close(CAN C^tF[XN[Y܂B)\n");

	if(!ICN_Time)
	{
		ICN_Time = 0;
	}

	if(String[0])
	{
		printf(	"ICN_Close(%ld,%s)\n",
				MAC,
				String);
	}

	if(!hDeviceHandle[MAC]) return 0;

	nRet = IFCAN_ERROR_SUCCESS;

	for(i=0;i<ICN_IF_cnt;i++)
	{
		if(ICN_IF[i].hDeviceHandle == hDeviceHandle[MAC])
		{
#ifndef SimCAN
			nRet = CanGetStatus(hDeviceHandle[MAC],&pStatus);	// Xe[^X
#else
			Sleep(1);
			nRet					= IFCAN_ERROR_SUCCESS;
			pStatus.ulBusStatus		= CAN_BUS_ACTIVE;
			pStatus.ulRXBCount		= 0;
			pStatus.ulTXBCount		= 0;
			pStatus.ulERBCount		= 0;
			pStatus.ulRXERRCount	= 0;
			pStatus.ulTXERRCount	= 0;
#endif
			if(nRet)
			{
				printf("error\t: ICN_Close(擾s)\n");
				return nRet; // G[
			}

			switch(pStatus.ulBusStatus)
			{
			case CAN_BUS_ACTIVE:
				printf("<oXANeBu>\t");
				printf(" M=%d,"		,pStatus.ulTXBCount);
				printf(" M=%d,"		,pStatus.ulRXBCount);
				printf(" MG[=%d,"	,pStatus.ulTXERRCount);
				printf(" MG[=%d\n"	,pStatus.ulRXERRCount);
				break;
			case CAN_BUS_PASSIVE:
				printf("<oXpbVu>\t");
				printf(" M=%d,"		,pStatus.ulTXBCount);
				printf(" M=%d,"		,pStatus.ulRXBCount);
				printf(" MG[=%d,"	,pStatus.ulTXERRCount);
				printf(" MG[=%d\n"	,pStatus.ulRXERRCount);
				break;
			case CAN_BUS_OFF:
				printf("<oXIt>\t");
				printf(" M=%d,"		,pStatus.ulTXBCount);
				printf(" M=%d,"		,pStatus.ulRXBCount);
				printf(" MG[=%d,"	,pStatus.ulTXERRCount);
				printf(" MG[=%d\n"	,pStatus.ulRXERRCount);
				break;
			default:
				printf("<ԕs>\t");
				printf(" M=%d,"		,pStatus.ulTXBCount);
				printf(" M=%d,"		,pStatus.ulRXBCount);
				printf(" MG[=%d,"	,pStatus.ulTXERRCount);
				printf(" MG[=%d\n"	,pStatus.ulRXERRCount);
				break;
			}

#ifndef SimCAN
			nRet = CanClosePort(hDeviceHandle[MAC]);	// CAN|[gN[Y
#else
			Sleep(1);
			nRet = IFCAN_ERROR_SUCCESS;
#endif
			ICN_IF[i].hDeviceHandle = 0;
			break;
		}
	}

	if(nRet)
	{
		printf("error\t: ICN_Close(CAN|[gN[Ys)\n");
		return nRet;
	}

//	printf("out\t: ICN_Close(CAN C^tF[XN[Y܂B)\n");
	return 0;
}
