//-----------------------------------------------------------------------------
//	ICN_Send_SS_cpp										A.Fukumori	2007/07/15
//
//	vgRˑFICN		n[hˑFWindows, CANCard
//-----------------------------------------------------------------------------
//	2007/05/21	A.Fukumori	
//	2007/05/24	A.Fukumori	CAN_Send
//	2007/05/26	A.Fukumori	JI
//	2007/06/02	A.Fukumori	ICNUPC̋ʉiICNNPA͐tō݉\j


//-----------------------------------------------------------------------------
//	include
//-----------------------------------------------------------------------------
#include	<windows.h>
#include	<stdio.h>		// C:		printf()
#include	<mmsystem.h>	// Windows:	timeGetTime()
#include	"sim.h"
#include	"IFCan.h"		// CANCard:	...
#include	"IFCANPF.h"		// CANCard:	...
#include	"ICN.h"


//-----------------------------------------------------------------------------
//	
//-----------------------------------------------------------------------------
extern		unsigned long	ICN_Time;
extern		HANDLE			hDeviceHandle[512];
extern		ICN_BOX			icn_box[512];


//-----------------------------------------------------------------------------
//	ICN bZ[W̑Ms܂B
//-----------------------------------------------------------------------------
inline int	ICN_Send_SS	(unsigned long	MAC,
						 unsigned char	DATA_ID1,
						 unsigned int	DATA1,
						 unsigned char	DATA_ID2,
						 unsigned int	DATA2,
						 char*			String)
{
	static CAN_MESSAGE	CanMessage;
	unsigned long		Time;
	int					nRet;

//	printf("in\t: ICN_Send_SS(ICNbZ[W̑Ms܂B)\n");	

	CanMessage.ulID		= MAC;				// CAN_ID
	CanMessage.bData[0]	= 0x01;				// BYTE0
	CanMessage.bData[1]	= DATA_ID1;			// BYTE1
	CanMessage.bData[2]	= DATA1;			// BYTE2
	CanMessage.bData[3]	= DATA1>>8;			// BYTE3
	CanMessage.bData[4]	= 0x07;				// BYTE4
	CanMessage.bData[5]	= DATA_ID2;			// BYTE5
	CanMessage.bData[6]	= DATA2;			// BYTE6
	CanMessage.bData[7]	= DATA2>>8;			// BYTE7
	CanMessage.ulLength	= 8;				// Length
	CanMessage.ulTime	= 0;				// Time
	CanMessage.ulFlag	= 0;				// Flag

#ifndef SimCAN
	nRet = CanSendMessage(hDeviceHandle[MAC],&CanMessage,1); // CANbZ[WM
#else
	Sleep(1);
	nRet = IFCAN_ERROR_SUCCESS;
#endif
	if(nRet)
	{
		printf("error\t: ICN_Send_SS(CANbZ[WMs)\n");
		return nRet;
	}

	Time								= timeGetTime()-ICN_Time;
	icn_box[MAC].ID[DATA_ID1].TX_Time	= Time;
	icn_box[MAC].ID[DATA_ID2].TX_Time	= Time;
	icn_box[MAC].ID[DATA_ID1].Enable	= 0;
	icn_box[MAC].ID[DATA_ID2].Enable	= 0;

	if(String[0])
	{
		printf(	"TX:<%s>\tT=%ld, CAN=%3d, ID=%3d, DATA=%d\n"
				"TX:<%s>\tT=%ld, CAN=%3d, ID=%3d, DATA=%d\n",
				String,
				Time,
				MAC,
				DATA_ID1,
				DATA1,
				String,
				Time,
				MAC,
				DATA_ID2,
				DATA2);
	}

//	printf("out\t: ICN_Send_SS(ICNbZ[W̑Ms܂B)\n");
	return nRet;
}
